#include <PCF8574.h>
  
byte displaySeteSeg[10][7] = { // array com todos os digitos de zero a nove  
 { 1,1,1,1,1,1,0 },  //DIGITO 0
 { 0,1,1,0,0,0,0 },  //DIGITO 1
 { 1,1,0,1,1,0,1 },  //DIGITO 2
 { 1,1,1,1,0,0,1 },  //DIGITO 3
 { 0,1,1,0,0,1,1 },  //DIGITO 4
 { 1,0,1,1,0,1,1 },  //DIGITO 5
 { 1,0,1,1,1,1,1 },  //DIGITO 6
 { 1,1,1,0,0,0,0 },  //DIGITO 7
 { 1,1,1,1,1,1,1 },  //DIGITO 8
 { 1,1,1,1,0,1,1 }   //DIGITO 9 
};

/* PCF8574P - Para os semáforos Pedonais */
PCF8574 pcf_Display1(0x39); // 0x39 Endereço do PCF8574P

 // Portas a usar pelos LEDs dos semáforos pedonais
const int LedR1 = 7;
const int LedG1 = 6;
const int LedR2 = 5;
const int LedG2 = 4;

const int temp3 = 5000; // Tempo que vai demorar a mudar de sinal (tempo LED Verde Veiculos + tempo LED Amarelo)
 
void setup() {
  Serial.begin(9600);  // Inicia o monitor de serie para monitorizar o circuito
  for(int i=0; i<=7; i++){ 
    pcf_Display1.pinMode(i, OUTPUT);
  }
  pcf_Display1.begin(); 

  for(int i=4; i<=7; i++){ // pinMode das portas dos semáforos pedonais
    pinMode(i, OUTPUT);
  }

  /* Inicia o sistema */  
  // Inicializar semáforos pedonais
  for(int i=4; i<=7; i++){
    digitalWrite(i, LOW);
  }
  ligaSegmentosDisplay1(0); // Coloca o display 1 com o valor zero
}

void loop() {  
  // Ligar semáforos
  digitalWrite(LedR1, HIGH); // Pedonal - Liga LED Vermelho 1
  digitalWrite(LedG2, HIGH); // Pedonal - Liga LED Verde 2  
  digitalWrite(LedR2, LOW); // Pedonal - Desliga LED Vermelho 2
  digitalWrite(LedG1, LOW); // Pedonal - Desliga LED Verde 1
  delay(temp3);  
  digitalWrite(LedR1, LOW); // Desliga LED Vermelho 1
  digitalWrite(LedG2, LOW); // Desliga LED Verde 2
  digitalWrite(LedR2, HIGH); // Liga LED Vermelho 2
  digitalWrite(LedG1, HIGH); // Liga LED Verde 1
  for(int i=5; i>=0; i--){ // Tempo dado até mudar de sinal  e ao mesmo tempo dá os segundos até mudar de sinal
    ligaSegmentosDisplay1(i);
    delay(1000);       
  }
}

void ligaSegmentosDisplay1(byte digito){ //função para acionar o display com o digito correspondente   
  byte pino = 0;
   
  //Liga os segmentos de acordo com o digito correspondente
  for (byte contadorSegmentos = 0; contadorSegmentos < 7; ++contadorSegmentos){ 
    pcf_Display1.digitalWrite(pino, displaySeteSeg[digito][contadorSegmentos]);
    Serial.print(pino);
    Serial.print(" - ");
    Serial.print(digito);
    Serial.print(" - ");
    Serial.println(contadorSegmentos);
    pino++; 
  }
}
